import re
import sys

word = re.compile('^[a-z]{1,20}\n$')

first = sys.stdin.readline()
assert word.match(first)

line = sys.stdin.readline()
assert re.match('^(0|[1-9][0-9]*)\n$', line)
n = int(line)
assert 0 <= n <= 100000

words = set([word])

for i in range(n):
    line = sys.stdin.readline()
    assert word.match(line)
    assert line not in words
    words.add(line)

assert sys.stdin.readline() == ''

sys.exit(42)

